/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig

#######################################################################################*/

#include "main.h"
#include "ethernet.h"
#include "socket.h"
#include "udp.h"
#include "blinkenled.h"
//Prototype
int get (void);
#if defined (__AVR_ATmega32__) 
 SIGNAL (SIG_INTERRUPT0);
#endif
#if defined (__AVR_ATmega169__)
 SIGNAL (SIG_INTERRUPT0);
#endif
#if defined (__AVR_ATmega103__)
 SIGNAL (SIG_INTERRUPT4);
#endif 
#if defined (__AVR_ATmega128__)
 SIGNAL (SIG_INTERRUPT4);
#endif


#if defined (__AVR_ATmega32__) 
 SIGNAL (SIG_INTERRUPT0)
#endif

#if defined (__AVR_ATmega169__) 
 SIGNAL (SIG_INTERRUPT0)
#endif

#if defined (__AVR_ATmega103__)
 SIGNAL (SIG_INTERRUPT4)
#endif
 
#if defined (__AVR_ATmega128__)
 SIGNAL (SIG_INTERRUPT4)
#endif

#if defined (__AVR_ATmega8__) 
 SIGNAL (SIG_INTERRUPT0)
#endif
{
 //printf ("interrupt\n");
 //Globale Interrupts Ausschalten
 cli ();
 //printf("int\n");
 char ByteH = 0;
 char ByteL = 1;  

 //if the receive buffer has been overrun
 if ( (ReadRTL(ISR)&(1<<OVW)) != 0)
  {
  //printf ("Overrun!\n");
  }
  
 //gehe zu Routine GET wenn ein Packet empfangen wurde
 if ( (ReadRTL(ISR) & (1<<PRX)) != 0)
  {
  //NIC FIFO noch nicht leer
  //gehe zu Routine GET und lese ein weiteres Packet
  while (ByteL != ByteH) //(!= bedeutet ungleich)
   {
   get ();
   
   //auslesen des Empfangsbuffer BNRY = CURR 
   ByteL = ReadRTL(BNRY); //auslesen NIC Register bnry
   WriteRTL ( CR ,(1<<STA|1<<RD2|1<<PS0));

   ByteH = ReadRTL(CURR); //auslesen NIC Register curr
   WriteRTL ( CR ,(1<<STA|1<<RD2));
   } 
  }
  
 //Zurcksetzen der Interrupt Bits des NIC
 WriteRTL (ISR, (1<<PRX|1<<PTX|1<<RXE|1<<TXE|1<<OVW|1<<CNT|1<<RDC|1<<RST));
 
 //startet die Network Card
 Networkcard_Start();
 
 //Globale wieder Interrupts Einschalten
 sei ();
}

//############################################################################
//Hier werden daten empfangen und geprft was empfangen wurde 
int get (void)
//############################################################################
{
 //lnge des Ethernetpacketes
 unsigned int packetlen;

 //Array fr zu empfangene Daten und zu sendene Daten
 unsigned char packet[MTU_SIZE];
 
 //Pointer auf Ethernet_Header
 struct Ethernet_Header *ethernet;
 ethernet = (struct Ethernet_Header *)&packet[ETHER_OFFSET];
// ethernet = packet+ETHER_OFFSET;
 //Pointer auf IP_Header
 struct IP_Header *ip;
 ip = (struct IP_Header *)&packet[IP_OFFSET];
 //Pointer auf TCP_Header
/* struct TCP_Header *tcp;
 tcp = (struct TCP_Header *)&packet[TCP_OFFSET];*/

 struct UDP_Header *udp;
 udp = (struct UDP_Header *)&packet[UDP_OFFSET];
 
 //Lese daten aus NIC FIFO ins Array packet() sowie packetheader()
 Read_Ethernet_Frame (packet,&packetlen); 
 
 //wurde ein ARP packet empfangen?
 //2 Byte fr Nutzlastbereich (0806 fr ARP)
 if(Ethernet_ARP_Datagramm)
  {
  //Erzeugt ein ARP Reply Packet
  ARP_Reply(packet,&packetlen);
  }
 
 //wurde ein ICMP, UDP oder TCP packet empfangen?
 //2 Byte fr Nutzlastbereich (0800 fr IP) 
 //Ist das IP Packet fr meine IP Addresse bestimmt
 else
 { 
  if(Ethernet_IP_Datagramm && MyIP){
  //Ist protokoll Byte = 1 dann ist es ein ICMP Packet
 /* if(IP_ICMP_Packet)
   {
   //Erzeugt ein ICMP Reply Packet (PING Echo)
   //printf("icmp\n");
   ICMP_Reply(packet,packetlen);
   }
   else */if(IP_UDP_Packet)
   {
   if (udp->UDP_DestPort == SOCKET_BLINKENLIGHTS){
	unsigned int temp;
	temp = udp->UDP_PacketLen << 8;
	temp |= udp->UDP_PacketLen>>8;
    blinkendata(packet+UDP_DATASTART,temp-UDP_HEADERLEN);
   }
   }
  }
 }
return (0);
}


