/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig

#######################################################################################*/

#ifndef _MAIN_H
 #define _MAIN_H

//#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include <avr/signal.h>
#include <avr/eeprom.h>

#include "rtl8019.h"

#include "arp.h"
#include "ip.h"
#include "icmp.h"
#include "uart.h"
#include "blinkenled.h"

#define USE_HTTPD	1

extern int checksum (unsigned char * ,unsigned int,unsigned long);
#if USE_HTTPD
extern void httpd (char* buffer,int *bufferlen);
#endif

extern const unsigned char mymac[];
extern const unsigned char MYIP[];
//MTU Size setzen (min. 500 / max. 1400)
#define MTU_SIZE  500

//Der Quarz auf dem Experimentierboard hat eine Frequenz von 14.318MHz
#define SYSCLK	8000000	//Quarz Frequenz in Hz
//#define SYSCLK	16000000	//Quarz Frequenz in Hz

#if defined (__AVR_ATmega103__)
	#define Networkcard_INT_Enable()	enable_external_int (1<<INT4);
#endif
	
#if defined (__AVR_ATmega128__)
	#define Networkcard_INT_Enable()	enable_external_int (1<<INT4);
#endif

#if defined (__AVR_ATmega169__)
	#define Networkcard_INT_Enable()	enable_external_int (1<<INT0);
#endif
	
#if defined (__AVR_ATmega32__)	
	#define Networkcard_INT_Enable()	enable_external_int (1<<INT0);
#endif	

#if defined (__AVR_ATmega32__)	
	#define Networkcard_INT_Set()	MCUCR=0x01;
#endif

#if defined (__AVR_ATmega169__)
	#define Networkcard_INT_Set()	EICRA = 0x03;
#endif
	
#if defined (__AVR_ATmega103__)
	#define Networkcard_INT_Set()	EICR = 0x03;
#endif
	
#if defined (__AVR_ATmega128__)
	#define Networkcard_INT_Set()	EICR = 0x03;
#endif

#endif //_MAIN_H






